#ifndef lint
static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/subs/move.c,v 2.6 1995/10/24 04:38:13 empire Exp $";
#endif

/*
 * move.c
 *
 * Move something somewhere.  Has a weight,
 * returns move cost, and fills a result parameter
 * with the destination sector.
 *
 *
 */

#include "misc.h"
#include "player.h"
#include "var.h"
#include "sect.h"
#include "item.h"
#include "file.h"
#include "deity.h"
#include "xy.h"
#include "path.h"
#include "nat.h"
#include "map.h"
#include "nsc.h"
#include "damage.h"

extern int move_map();

int
move_ground(what, start, end, weight, path, map, exploring, dam,
	    usedx, usedy, mobcost, minmobstr)
	s_char	*what;
	struct	sctstr *start;
	struct	sctstr *end;	/* RESULT */
	double	weight;
	s_char	*path;
	int	(*map)();
	int	exploring, *dam;
        coord   *usedx, *usedy;
        int     *mobcost;
        s_char  *minmobstr;

{
	struct	sctstr sect, ending_sect;
	struct	sctstr next, dsect;
	int	vec[I_MAX+1];
	coord	curx, cury, oldx, oldy;
	coord	tmpx, tmpy;
	coord	dx, dy;
	s_char	*movstr;
	double	sect_mcost;
	double	total_mcost;
	double	mv_cost;
	int	dir;
	int	intcost;
	int	d, takedam = (*dam), out=0;
	s_char	bpath[512];
	s_char	buf2[512];
	s_char	prompt[128];
	s_char	buf[1024];
	int     curstart = 0;
	int     numsect = 1;
	int     minmob;
	double  mobility = (double)start->sct_mobil;

	extern int sect_mob_max;

	/* initalize minmob */
	if (minmobstr && atoi(minmobstr)) {
	  minmob = atoi(minmobstr);
	  if (minmob < 0) {
	    pr("Minimum mobility must be greater than zero.\n");
	    return -1;
	  } else if (minmob >sect_mob_max) {
	    pr("Minimum mobility must be less than %d.\n", (int)(sect_mob_max+1));
	    return -1;
	  }
	} else minmob = -1;

	/* initalize start sector */
	usedx[0] = start->sct_x;
	usedy[0] = start->sct_y;
	mobcost[0] = 0;

	*dam = 0;
        if (path && sarg_xy(path, &dx, &dy) && getsect(dx,dy,&ending_sect)){
		if ((ending_sect.sct_x == start->sct_x) &&
			(ending_sect.sct_y == start->sct_y)){
			pr("Start sector is ending sector!\n");
			return -1;
		}
		pr("Looking for best path to %s\n", path);
		path = BestLandPath(buf2, start, &ending_sect, &total_mcost);
		if (exploring && (path != (s_char *)0)) /* take off the 'h' */
			*(path+strlen(path)-1) = '\0';
		if (path == (s_char *)0)
			pr("No owned path exists!\n");
		else{
			pr("Using best path '%s', movement cost %1.3f\n",
				path,total_mcost);
       			bzero(bpath,512);
			bcopy(path,bpath,strlen(path));
			path = bpath;
		}
		if ((total_mcost*weight) > mobility && minmob < 0){
			pr("Not enough mobility to go all the way. Nothing moved.\n");
			*end = *start;
			return -1;
		}
	}
	/* at this point path contains the text direction string to make
         * the move
	 */
	if (minmob >= 0) {
          if (path == (s_char *)0)
            pr("No owned path exists!\n");
       	  /* fill_path_list parses the move string into a list of sectors */
	  /* with mobility above minmob in absolute coordinates */
	  else
	    numsect = fill_path_list(usedx, usedy, mobcost, path, minmob, buf2, weight);
	  if (numsect == -1) {
	    pr("Not enough mobility on path to make move.\n");
	    *end = *start;
	    return -1;
	  } else if (numsect == -2) {
	    pr ("Invalid path '%s'\n", path);
	    minmob = -1;
	  } else if (numsect == 0) {
	    pr("Start sector is same as end sector.\n");
	    *end = *start;
	    return -1;
	  } else if (numsect == -3) {
	    pr("Too many sectors along the path are using mobility.\n");
	    pr("Tell the deity that 'MAXROUTE' in path.h must be increased\n");
	    *end = *start;
	    return -1;
	  }	  
	  bzero(bpath,512);
	  bcopy(buf2,bpath,strlen(buf2));
	  path = bpath;
	}
	movstr = path;
	tmpx = start->sct_x;
	curx = tmpx;
	tmpy = start->sct_y;
	cury = tmpy;
	if (getsect(curx, cury, &sect) < 0) {
		logerror("move_path: getsect %d,%d", curx, cury);
		*end = *start;
		return -1;
	}
	while (curstart < numsect) {
	  
	  total_mcost = 0.0;
	  for (;;) {
	    tmpx = curx;
	    tmpy = cury;
	    oldx = curx;
	    oldy = cury;
	    if (movstr == 0 || *movstr == 0) {
	      if (exploring) {
		map(what, curx, cury, (s_char *)0); }
	      else {
		move_map(what, curx, cury, (s_char *)0); }
	      sprintf(prompt, "<%.1f: %c %s> ", mobility,
		      dchr[sect.sct_type].d_mnem,
		      xyas(sect.sct_x, sect.sct_y, player->cnum));
	      movstr = getstring(prompt, buf);
	    }
	    if (movstr && sarg_xy(movstr, &dx, &dy)){
	      if (getsect(dx,dy,&dsect)){
		movstr=BestLandPath(buf2,&sect,&dsect,&mv_cost);
	      }else{
		pr("Invalid destination sector!\n");
		movstr=(s_char *)0;
	      }
	      
	      if (movstr == (s_char *)0){
		pr("Can't get to %s from here!\n",
		   xyas(dx,dy,player->cnum));
		movstr=(s_char *)0;
	      }else{
		if ((mv_cost*weight) > mobility && minmob <0){
		  pr("Not enough mobility to go all the way. Nothing moved.\n");
		  movstr = (s_char *)0;
		}else{
		  if (minmob < 0) {
		    pr("Using best path from %s to %s '%s', movement cost %1.3f\n",
		       xyas(usedx[curstart], usedy[curstart], player->cnum),  
		       xyas(dx, dy, player->cnum),     
		       movstr,mv_cost);
		  bzero(bpath,512);
		  bcopy(movstr,bpath,strlen(movstr));
		  movstr = bpath;
		} else {
	          dir = fill_path_list(usedx, usedy, mobcost, movstr, minmob, buf2, weight);
	          if (dir == -1) {
	            pr("Not enough mobility on path to make move.\n");
	          } else if (dir == -2) {
	            pr ("Invalid destination sector\n");
	          } else if (dir == 0) {
	            pr("Start sector is same as end sector.\n");
	          } else if (dir == -3) {
	            pr("Too many sectors along the path are using mobility.\n");
	            pr("Tell the deity that 'MAXROUTE' in path.h must be increased\n");
	            *end = *start;
	            return -1;
	          } else {	  
	            bzero(bpath,512);
	            bcopy(movstr,bpath,strlen(movstr));
	            movstr = bpath;
		  }
		  }
		}
	      }
	    }
	    if (movstr == 0 || *movstr == 0)
	      movstr = dirch;
	    if ((dir = chkdir(*movstr, DIR_STOP, DIR_SWITCH)) < 0) {
	      pr("\"%c\" is not legal...", *movstr);
	      direrr("'%c' to stop ", "'%c' to view ",
		     "& '%c' to map\n");
	      *movstr = 0;
	      continue;
	    }
	    movstr++;
	    if (dir == DIR_MAP) {
	      if (!exploring)
		map(what, curx, cury, movstr+1);
	      *movstr = 0;
	      continue;
	    } else if (dir == DIR_STOP)
	      break;
	    else if (dir == DIR_VIEW) {
	      pr("%d%% %s with %d civilians.\n", sect.sct_effic,
		 dchr[sect.sct_type].d_name,
		 getvar(V_CIVIL, (s_char *)&sect, EF_SECTOR));
	      continue;
	    } else if (dir == DIR_SWITCH) {
	      if (numsect < (MAXROUTE-1)) {
	        if (!add_sector_list(curx, cury, curstart, numsect, usedx, usedy, mobcost)) {
		  pr("This sector is already being drained of mobility!\n");
		  continue;
		} else {
		  numsect++;
		  break;
		}
	      } else 
	        pr("Cannot use that many sectors for mobility, Source not changed.");	    
	    }
	    /*
	     * now see if we can move into the
	     * next sector.  Mobility, terrain,
	     * or ownership may prevent us.
	     */
	    tmpx += diroff[dir][0];
	    tmpy += diroff[dir][1];
	    if (getsect(tmpx, tmpy, &next) < 0) {
	      pr("You can't go there...\n");
	      *movstr = 0;
	      continue;
	    }
	    if (!player->god) {
	      if ((next.sct_type == SCT_SANCT) &&
		  (next.sct_own != player->cnum)) {
		pr("Converts, huh?\n");
		*end = next;
		mobcost[curstart] = (int) total_mcost;
		if (chance(total_mcost - intcost))
		  mobcost[curstart]++;
		return curstart;
	      }
	      getvec(VT_ITEM, vec, (s_char *)&next, EF_SECTOR);
	      sect_mcost = sector_mcost(next.sct_type,next.sct_effic);
	      if ((!player->owner && (!exploring || 
				      (vec[I_MILIT] || vec[I_CIVIL]))) ||
		  sect_mcost == -1.0) {
		/* already-owned, or prohibited terrain */
		pr("You can't go there...\n");
		*movstr = 0;
		continue;
	      }
	      sect_mcost *= weight;
	      if (sect_mcost > mobility && minmob < 0) {
		pr("Not enough mobility.  ");
		pr("You can't go there...\n");
		*movstr = 0;
		continue;
	      }
	      mobility -= sect_mcost;
	      total_mcost += sect_mcost;
	    }
	    curx = tmpx;
	    cury = tmpy;
	    if (cury != start->sct_y)
	      out=1;
	    if (curx != start->sct_x)
	      out=1;
	    
	    sect = next;
	    
	    if (takedam)
	      *dam += check_lmines(sect.sct_x, sect.sct_y, weight);
	    if (*dam >= 100)
	      break;
	    /*
	     * Check and see if anyone will interdict us
	     */
	    if (takedam && chance(weight/100.0) &&
		((curx != oldx) || (cury != oldy)))
	      (*dam) += ground_interdict(curx,cury,player->cnum,"commodities");
	    if (*dam >= 100)
	      break;
	  }
	  if (chance(total_mcost - (int)total_mcost))
	    total_mcost++;
	  mobcost[curstart] = (int)total_mcost;
	  getsect(usedx[curstart], usedy[curstart], &next);
        
	  total_mcost = 0;
          mobility = (double)sect.sct_mobil;
          
	  if ((next.sct_mobil - mobcost[curstart]) < 0) {
	    /* somehow we got a negative mobility, ABORT */
	    *end = *start;
	    return -1;
	  }
	  curstart++;
	}

	*end = sect;
	if ((start->sct_x == end->sct_x) && (start->sct_y == end->sct_y) && !out){
	        *end = *start;
		return -1;
	}
	return curstart;
}


/*ARGSUSED*/
int
move_map(what, curx, cury, arg)
        s_char    *what;
        coord   curx, cury;
        s_char    *arg;
{
        struct  nstr_sect ns;
        struct  natstr *np;
        struct  sctstr sect;
        coord   rel_x, rel_y;
        s_char    range[128];
        s_char    view[7];
        int     i;
        int     vec[I_MAX+1];
	int	changed = 0;
 
        np = getnatp(player->cnum);
        rel_x = xrel(np, curx);
        rel_y = yrel(np, cury);
        sprintf(range, "%d:%d,%d:%d", rel_x-2, rel_x+2, rel_y-1, rel_y+1);
        player->condarg = 0;
	/* This is necessary, otherwise move_map would attempt to pay */
	/* attention to the conditional arguments left behind by such */
	/* a command as "tran p -1,-1 ?eff=100".. It'd then only see  */
	/* 100% efficienct sects, and get all screwed up         --ts */
        if (!snxtsct(&ns, range))
                return RET_FAIL;
        i = 0;
        while (i < 7 && nxtsct(&ns, &sect)) {
                view[i] = dchr[sect.sct_type].d_mnem;
                switch (sect.sct_type) {
                case SCT_WATER:
                case SCT_RURAL:
                case SCT_MOUNT:
                case SCT_WASTE:
                        break;
                default:
                        if (sect.sct_own != player->cnum && !player->god)
                                view[i] = '?';
                        break;
                }
		changed += map_set(player->cnum, ns.x, ns.y, view[i], 0);
                i++;
        }
	if (changed)
		writemap(player->cnum);
        if (!getsect(curx, cury, &sect))
                return RET_FAIL;
        getvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
        pr("    %c %c      eff   mob   civ  mil   uw food  work  avail\n",
                view[0], view[1]);
        pr("   %c %c %c     %3d   %3d  %4d %4d %4d %4d   %3d   %3d\n",
                view[2], view[3], view[4],
                sect.sct_effic, sect.sct_mobil, vec[I_CIVIL],vec[I_MILIT],
        	vec[I_UW],vec[I_FOOD], sect.sct_work, sect.sct_avail);
        pr("    %c %c\n", view[5], view[6]);
        return RET_OK;
}

int
fly_map(curx, cury)
coord	curx, cury;
{
        struct  nstr_sect ns;
        struct  natstr *np;
        struct  sctstr sect;
        coord   rel_x, rel_y;
        s_char    view[7];
        int     i;
	s_char	range[128];
 
        np = getnatp(player->cnum);
        rel_x = xrel(np, curx);
        rel_y = yrel(np, cury);
        sprintf(range, "%d:%d,%d:%d", rel_x-2, rel_x+2, rel_y-1, rel_y+1);
        player->condarg = 0;
	/* This is necessary, otherwise move_map would attempt to pay */
	/* attention to the conditional arguments left behind by such */
	/* a command as "tran p -1,-1 ?eff=100".. It'd then only see  */
	/* 100% efficienct sects, and get all screwed up         --ts */

        if (!snxtsct(&ns, range))
                return RET_FAIL;
        i = 0;
        while (i < 7 && nxtsct(&ns, &sect)){
                if (!(view[i] = player->bmap[sctoff(ns.x, ns.y)]))
			view[i] = ' ';
                i++;
        }

        pr("    %c %c\n",view[0], view[1]);
        pr("   %c %c %c\n", view[2], view[3], view[4]);
        pr("    %c %c\n", view[5], view[6]);
        return RET_OK;
}

int
check_lmines(x, y, weight)
	coord	x,y;
	double	weight;
{
	struct	sctstr	sect;
	int	mines;
	int	dam = 0;

	getsect(x, y, &sect);
	mines = getvar(V_MINE, (s_char *)&sect, EF_SECTOR);
	if (mines > 0 &&
	    sect.sct_oldown != player->cnum &&
	    chance(DMINE_LHITCHANCE(mines)) &&
	    chance(weight/100.0)) {
		pr_beep();
		pr("Blammo! Landmines detected! in %s  ",
		   xyas(sect.sct_x,sect.sct_y,player->cnum));
		dam = roll(20);
		--mines;
		putvar(V_MINE, mines, (s_char *)&sect, EF_SECTOR);
		putsect(&sect);
		pr("%d damage sustained.\n", dam);
	}
	return dam;
}



int fill_path_list(usedx, usedy, mobcost, path, minmob, newpath, weight)
     coord *usedx;
     coord *usedy;
     int   *mobcost;
     s_char *path;
     int   minmob;
     s_char *newpath;
     double weight;
{
  int i, dir;
  int cursect = 1;
  s_char *current = path;
  coord x = usedx[0];
  coord y = usedy[0];
  struct sctstr sect;
  struct sctstr sta;
  struct sctstr end;
  double mcost;
  s_char hop[512];
  s_char *temp;
  s_char stopchar;
  int loop = 1;

  *newpath = '\0';
  if ( *(path+strlen(path)-1) == 'h') stopchar = 'h'; else stopchar = '\0';
  
/* parse the list into smaller jumps */
  for (i=0; i < strlen(path); i++) {
    
    if ((dir = chkdir(*current, DIR_STOP, DIR_SWITCH)) < 0) {
      return -2;
    }
    current++;
    if (dir == DIR_MAP) {
      continue;
    } else if (dir == DIR_STOP)
      break;
    else if (dir == DIR_VIEW) {
      continue;
    }
    else if (dir == DIR_SWITCH) {
      continue;
    }

    x += diroff[dir][0];
    y += diroff[dir][1];

    if (getsect(x, y, &sect) < 0) return -2;
    if ((player->cnum != sect.sct_own)&& sect.sct_own != 0) return -2;

    if (minmob < sect.sct_mobil) {
      usedx[cursect] = x;
      usedy[cursect] = y;
      mobcost[cursect] = 0;
      cursect++;
    }
  }
/* put the ending sector on the list if it's not there */
  if (x==usedx[cursect-1] && y == usedy[cursect-1]) cursect--;
  usedx[cursect] = x;
  usedy[cursect] = y;



/* now trim the list down into jumps with enough mobility */
  while (loop) {
    loop = 0;
    for (i=0; i < cursect; i++) {
      getsect(usedx[i], usedy[i], &sta);
      getsect(usedx[i+1], usedy[i+1], &end);
      temp = BestLandPath(hop, &sta, &end, &mcost);
      if (temp == (s_char  *)0) return -2;
      else if (minmob >= (sta.sct_mobil-(int)(mcost*weight)) ||
	       (usedx[i] == usedx[i+1] && usedy[i]==usedy[i+1])) {
	reset_mobility_and_remove_sector(i, usedx, usedy, mobcost, cursect);
	cursect--;
	if (cursect == 0) return -1;
	*newpath = '\0';
	loop = 1;
	break;
      }
      /* note the switch */
      *(temp+strlen(temp)-1) = 's';
      /* add the hop */
      strcat(newpath, temp);
    }
  }
   *(newpath+strlen(newpath)-1) = stopchar;
/* we have a valid path */
  return 1;
}

int reset_mobility_and_remove_sector(curstart, usedx, usedy, mobcost, numsect)
     int   curstart;
     coord *usedx;
     coord *usedy;
     int   *mobcost;
     int   numsect;
{
  int i, putsct = 0;
  struct sctstr sect;

  for (i=0; i<=numsect; i++){
    if (i != curstart) {
      getsect(usedx[i], usedy[i], &sect);
      mobcost[putsct] = 0;
      usedx[putsct] = usedx[i];
      usedy[putsct] = usedy[i];
      putsct++;
    }
  }
  return putsct;
}



int add_sector_list(x, y, current,numsect, usedx, usedy, mobcost)
	coord x;
	coord y;
	int   current;
	int   numsect;
	coord *usedx;
	coord *usedy;
	int   *mobcost;
{
  int i;
  
  for (i=0; i < numsect; i++)
    if ((x==usedx[i] && y == usedy[i])) return 0;
  
  for (i = numsect; i > current; i--) {
    usedx[i+1] = usedx[i];
    usedy[i+1] = usedy[i];
    mobcost[i+1] = mobcost[i];
  }
  usedx[current+1] = x;
  usedy[current+1] = y;
  mobcost[current+1] = 0;
  return 1;
}
